
#include "device_launch_parameters.h"
#include "cuda_runtime.h"
#include "helper_cuda.h"

#include "Matrix.h"

// Thread block size
#define BLOCK_SIZE 16


int main()
{
    Matrix h_A, h_B, h_C_gold;
    int a_rows = 64 * BLOCK_SIZE, a_cols = 32 * BLOCK_SIZE, b_cols = 16 * BLOCK_SIZE;

    CreateMatrix( h_A, a_rows, a_cols );
    CreateMatrix( h_B, a_cols, b_cols );
    CreateMatrix( h_C_gold, a_rows, b_cols );

    FillRandomMatrix( h_A );
    FillRandomMatrix( h_B );

    MatMul_CPU( h_A, h_B, h_C_gold );


    DestroyMatrix( h_A );
    DestroyMatrix( h_B );
    DestroyMatrix( h_C_gold );

    return 0;
}